<?php
/**
Oreon is developped with Apache Licence 2.0 :
http://www.apache.org/licenses/LICENSE-2.0.txt
Developped by : Julien Mathis - Romain Le Merlus - Cedrick Facon

The Software is provided to you AS IS and WITH ALL FAULTS.
OREON makes no representation and gives no warranty whatsoever,
whether express or implied, and without limitation, with regard to the quality,
safety, contents, performance, merchantability, non-infringement or suitability for
any particular or intended purpose of the Software found on the OREON web site.
In no event will OREON be liable for any direct, indirect, punitive, special,
incidental or consequential damages however they may arise and even if OREON has
been previously advised of the possibility of such damages.

For information : contact@oreon-project.org
*/

	#
	## pearDB init
	#
	require_once 'DB.php';
	
		function getMyHostField($host_id = NULL, $field)	{
		if (!$host_id) return;
		global $pearDB;
		while(1)	{
			$res =& $pearDB->query("SELECT ".$field.", host_template_model_htm_id FROM host WHERE host_id = '".$host_id."' LIMIT 1");
			if (PEAR::isError($pearDB))
				print "Mysql Error : ".$pearDB->getMessage();
			$row =& $res->fetchRow();
			$field_result = $row[$field];
			if ($row[$field])
				return $row[$field];
			else if ($row["host_template_model_htm_id"])
				$host_id = $row["host_template_model_htm_id"];
			else
				break;
		}
	}
	function getMyHostExtendedInfoField($host_id = NULL, $field)	{
		if (!$host_id) return;
		global $pearDB;
		while(1)	{
			$DBRESULT =& $pearDB->query("SELECT ehi.".$field.", h.host_template_model_htm_id FROM host h, extended_host_information ehi WHERE ehi.host_host_id = '".$host_id."' AND h.host_id = '".$host_id."' LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
			$row =& $DBRESULT->fetchRow();
			$field_result = $row[$field];
			if ($row[$field])
				return $row[$field];
			else if ($row["host_template_model_htm_id"])
				$host_id = $row["host_template_model_htm_id"];
			else
				break;
		}
	}
	function getMyServiceField($service_id = NULL, $field)	{
		if (!$service_id) return;
		global $pearDB;
		while(1)	{
			$DBRESULT =& $pearDB->query("SELECT ".$field.", service_template_model_stm_id FROM service WHERE service_id = '".$service_id."' LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
			$row =& $DBRESULT->fetchRow();
			$field_result = $row[$field];
			if ($row[$field])
				return $row[$field];
			else if ($row["service_template_model_stm_id"])
				$service_id = $row["service_template_model_stm_id"];
			else
				break;
		}
	}

	function getMyServiceExtendedInfoField($service_id = NULL, $field)	{
		if (!$service_id) return;
		global $pearDB;
		while(1)	{
			$DBRESULT =& $pearDB->query("SELECT esi.".$field.", sv.service_template_model_stm_id FROM service sv, extended_service_information esi WHERE esi.service_service_id = '".$service_id."' AND sv.service_id = '".$service_id."' LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
			$row =& $DBRESULT->fetchRow();
			$field_result = $row[$field];
			if ($row[$field])
				return $row[$field];
			else if ($row["service_template_model_stm_id"])
				$service_id = $row["service_template_model_stm_id"];
			else
				break;
		}
	}	
	function getMyHostIdFromNodeID($node_id) {
		global $pearDB;
		while(1)	{
			$DBRESULT =& $pearDB->query("SELECT host_host_id FROM pwm_host_node_relation WHERE node_id = '".$node_id."' LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
			$row =& $DBRESULT->fetchRow();
			$field_result = $row["host_host_id"];
			if ($row["host_host_id"])
				return $row["host_host_id"];
			else
				return NULL;
		}
		
	}
	function getMyHostServices($host_id = NULL)	{
		if (!$host_id) return;
		global $pearDB;
		$hSvs = array();
		$DBRESULT =& $pearDB->query("SELECT service_id, service_description FROM service, host_service_relation hsr WHERE hsr.host_host_id = '".$host_id."' AND hsr.service_service_id = service_id");
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		while ($DBRESULT->fetchInto($elem))
			$hSvs[$elem["service_id"]]	= $elem["service_description"];
		$DBRESULT->free();
		$DBRESULT =& $pearDB->query("SELECT service_id, service_description FROM hostgroup_relation hgr, service, host_service_relation hsr" .
				" WHERE hgr.host_host_id = '".$host_id."' AND hsr.hostgroup_hg_id = hgr.hostgroup_hg_id" .
				" AND service_id = hsr.service_service_id");
		if (PEAR::isError($DBRESULT)) 
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		while ($DBRESULT->fetchInto($elem))
			$hSvs[$elem["service_id"]]	= $elem["service_description"];
		$DBRESULT->free();
		return $hSvs;
	}	
	function getMyServiceIdFromNodeID($node_start_id, $node_end_id, $host_id) {
		global $pearDB;
		while(1)	{
			$DBRESULT =& $pearDB->query("SELECT service_service_id FROM pwm_host_link_relation WHERE host_host_id = '".$host_id."' AND node_start_id = '".$node_start_id."' AND node_end_id = '".$node_end_id."' LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
			$row =& $DBRESULT->fetchRow();
			$field_result = $row["service_service_id"];
			if ($row["service_service_id"])
				return $row["service_service_id"];
			else
				return NULL;
		}
		
	}
	
	$buffer = null;
	$buffer  = '<?xml version="1.0"?>';
	$buffer .= '<response>';

/*
		$_POST["oreonPath"] = "/srv/oreon/";
		$_POST["nodeID_start"] = "node1168441638";
		$_POST["nodeID_end"] = "node1168444780";
*/
	if(isset($_POST["oreonPath"]) && isset($_POST["nodeID_start"]) && isset($_POST["nodeID_end"]))
	{
		$oreonPath = $_POST["oreonPath"];
		include_once($oreonPath . "/www/oreon.conf.php");
		$dsn = array(
			     'phptype'  => 'mysql',
			     'username' => $conf_oreon['user'],
			     'password' => $conf_oreon['password'],
			     'hostspec' => $conf_oreon['host'],
			     'database' => $conf_oreon['db'],
			     );
		$options = array(
				 'debug'       => 2,
				 'portability' => DB_PORTABILITY_ALL ^ DB_PORTABILITY_LOWERCASE,
				 );
			
		$pearDB =& DB::connect($dsn, $options);
		if (PEAR::isError($pearDB)) 
		  die("Connecting probems with oreon database : " . $pearDB->getMessage());		
		$pearDB->setFetchMode(DB_FETCHMODE_ASSOC);


	$host_id = getMyHostIdFromNodeID($_POST["nodeID_start"]);
	$host_name = getMyHostField($host_id, "host_name");

	$service_id = getMyServiceIdFromNodeID($_POST["nodeID_start"], $_POST["nodeID_end"], $host_id);
	$service_id = is_null($service_id) ? 0 : $service_id;

	$ehi_notes_url = getMyHostExtendedInfoField($host_id,"ehi_notes_url");
	$ehi_icon_image = getMyHostExtendedInfoField($host_id,"ehi_icon_image");
	
	$ehi_notes_url = (is_null($ehi_notes_url)) ? "N/A" : $ehi_notes_url;
	$ehi_icon_image = (is_null($ehi_icon_image)) ? 0 : $ehi_icon_image;
	$tab_svc = getMyHostServices($host_id);

	$service_pos = 0;
	if(is_array($tab_svc))
	{
		$i=0;
		foreach($tab_svc as $key => $value)
		{
			if($key == $service_id)
			$service_pos = $i;
			$i++;
		}
	}

	$buffer .= '<host>';
	$buffer .= "<host_id>".$host_id."</host_id>";
	$buffer .= "<host_name>".$host_name."</host_name>";
	$buffer .= "<svc_id>".$service_pos."</svc_id>";
	$buffer .= "<ehi_notes_url>" . $ehi_notes_url . "</ehi_notes_url>";
	$buffer .= "<ehi_icon_image>" . $ehi_icon_image . "</ehi_icon_image>";
	$buffer .= '</host>';




	if(is_array($tab_svc))
	{
		foreach($tab_svc as $key => $value)
		{
			$buffer .= '<svc>';
			$buffer .= '<svc_description>'.$value .'</svc_description>';	
			$buffer .= '<svc_key>'.$key .'</svc_key>';	
			$buffer .= '</svc>';
		}
	}

	}
	else
	{
		$buffer .= '<error>error</error>';
	}

	$buffer .= '</response>';
	header('Content-Type: text/xml');
	echo $buffer;	
?>