<?php 
	require_once 'editor-config.php';
	require_once 'editor.inc.php';
	require_once 'Weathermap.class.php';
	
	$mode = NULL;
	# Mode drawing img
	if (isset($_GET["action"]) && $_GET["action"] == "draw")	{
		require_once '../../../../oreon.conf.php';
		require_once '../../../../DBconnect.php';
		require_once '../../../../include/common/common-Func.php';
		$DBRESULT =& $pearDB->query("SELECT oreon_path FROM general_opt LIMIT 1;");
		$ident = $DBRESULT->fetchrow();
		$pwm_path = $ident["oreon_path"]."www/modules/php-weathermap/configuration/pwm-editor/";
		$mode = "draw";
	} else	{
		$pwm_path = "modules/php-weathermap/configuration/pwm-editor/";
		$mode = "editor";
	}

   $mapdir = $pwm_path.$mapdir;
   
	$tmp = '<style type="text/css">
	@import url(./modules/php-weathermap/configuration/pwm-editor/editor.css);
	</style>';
	
	# relation with editor.css
	# it must be the same values of top and left for id: #xycapture and #existingdata
	$x_oreon = 220;
	$y_oreon = 160;
	
    $action = '';
    $mapname = '';
    $selected = '';
    
    $newaction = '';
    $param = '';
    $param2 = '';
    $log = '';
        
    module_checks();

    if(isset($_REQUEST['action'])) { $action = $_REQUEST['action']; }
    if(isset($_REQUEST['mapname'])) { $mapname = $_REQUEST['mapname']; }
    if(isset($_REQUEST['selected'])) { $selected = $_REQUEST['selected']; }

    if($mapname == '')
    {
        // this is the file-picker/welcome page
      //  show_editor_startpage();
       //echo "KO";
    }
	else
	{  
    // everything else in this file is inside this else
    $mapfile = $mapdir.'/'.$mapname;        

    $map = new WeatherMap;
    $map->context = "editor";


    switch($action)
    {
        case 'newmap':
           // $map->WriteConfig($mapfile);
            break;
        
        case 'font_samples':
            header('Content-type: image/png');

            $im = imagecreate(250,imagefontheight(5)+5);
            
            $white = imagecolorallocate($im,255,255,255);
            $black = imagecolorallocate($im,0,0,0);

            $x = 3;
            for($i=1; $i< 6; $i++)
            {
                imagestring($im, $i, $x, 2, "Font $i", $black);
                $x = $x + imagefontwidth($i)*7;
            }
            imagepng($im);
            imagedestroy($im);

            exit();        
            break;
        case 'draw':
            header('Content-type: image/png');
            $map->ReadConfig($mapfile);

            if($selected != '')
            {
                if(substr($selected,0,5) == 'NODE:')
                {
                    $nodename = substr($selected,5);
                    $map->nodes[$nodename]->selected=1;
                }
                
                if(substr($selected,0,5) == 'LINK:')
                {
                    $linkname = substr($selected,5);
                    $map->links[$linkname]->selected=1;
                }
            }

            $map->sizedebug = TRUE;
//            $map->RandomData();
            $map->DrawMap();
            exit();
            break;

	case 'show_config':
            	header('Content-type: text/plain');

		$fd = fopen($mapfile,'r');
		while (!feof($fd))
   		{
       			$buffer = fgets($fd, 4096);
       			echo $buffer;
   		}
		fclose($fd);

		exit();
		break;
        
        case "set_node_properties":
			$map->ReadConfig($mapfile);
			$node_name = $_REQUEST['node_name'];
			$new_node_name = $_REQUEST['node_name'];
			
			if (isset($_REQUEST['host_host_id_1']) && $_REQUEST['host_host_id_1'] && $_REQUEST['node_name'])	{
	          	$DBRESULT =& $pearDB->query("SELECT * FROM `pwm_host_node_relation` WHERE `node_id` = '".$_REQUEST['node_name']."'");
				if (PEAR::isError($DBRESULT))
					print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
				if ($DBRESULT->numRows())	{
		          	$DBRESULT =& $pearDB->query("UPDATE `pwm_host_node_relation` SET `host_host_id` = '".$_REQUEST['host_host_id_1']."' WHERE node_id = '".$_REQUEST['node_name']."'");
					if (PEAR::isError($DBRESULT))
						print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";		
				}
				else	{
		          	$DBRESULT =& $pearDB->query("INSERT INTO `pwm_host_node_relation` ( `phnr_id` , `host_host_id` , `node_id` ) VALUES (NULL , '".$_REQUEST['host_host_id_1']."', '".$_REQUEST['node_name']."'); ");
					if (PEAR::isError($DBRESULT))
						print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
				}
			}

            if($node_name != $new_node_name)
            {
                // we need to rename the node first.
            }

		$map->nodes[$node_name]->label = $_REQUEST['node_label'];
		if (!$_REQUEST['node_infourl'])
			$map->nodes[$node_name]->infourl = "NODEINFOURLTOCHANGE_".$_REQUEST['host_host_id_1'];
		else if (strstr($_REQUEST['node_infourl'], "NODEINFOURLTOCHANGE_"))
			$map->nodes[$node_name]->infourl = "NODEINFOURLTOCHANGE_".$_REQUEST['host_host_id_1'];
		else
			$map->nodes[$node_name]->infourl = $_REQUEST['node_infourl'];
		$map->nodes[$node_name]->overliburl = $_REQUEST['node_hover'];
		
		if($_REQUEST['node_iconfilename'] == '--NONE--')
		{
		    $map->nodes[$node_name]->iconfile='';    
		}
		else
		{
		    $map->nodes[$node_name]->iconfile = stripslashes($_REQUEST['node_iconfilename']);
		}
			
		$map->WriteConfig($mapfile);
                break;

        case "set_link_properties":
			        
			$map->ReadConfig($mapfile);
			$link_name = $_REQUEST['link_name'];

			$map->links[$link_name]->width = intval($_REQUEST['link_width']);
			
			$DBRESULT_index =& $pearDBO->query("SELECT id FROM index_data WHERE host_id = '".$_REQUEST['host_host_id_2']."' AND service_id = '".$_REQUEST['svc_id']."' LIMIT 1");
			$DBRESULT_index->fetchInto($index);

			if (!$_REQUEST['link_infourl'])
				$map->links[$link_name]->infourl = "LINKINFOURLTOCHANGE_".$index['id'];
			else if (strstr($_REQUEST['link_infourl'], "LINKINFOURLTOCHANGE_"))
				$map->links[$link_name]->infourl = "LINKINFOURLTOCHANGE_".$index['id'];
			else
				$map->links[$link_name]->infourl = $_REQUEST['link_infourl'];

			if (!$_REQUEST['link_hover'])
				$map->links[$link_name]->overliburl = "LINKHOVERURLTOCHANGE_generateODSImage.php?host_id=".$_REQUEST['host_host_id_2']."&svc_id=".$_REQUEST['svc_id'];
			else if (strstr($_REQUEST['link_hover'], "LINKHOVERURLTOCHANGE_"))
				$map->links[$link_name]->overliburl = "LINKHOVERURLTOCHANGE_generateODSImage.php?host_id=".$_REQUEST['host_host_id_2']."&svc_id=".$_REQUEST['svc_id'];
			else
				$map->links[$link_name]->overliburl = $_REQUEST['link_hover'];

			
			$DBRESULT =& $pearDBO->query("SELECT RRDdatabase_path FROM `config` LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";				
			$config = $DBRESULT->fetchRow();		

/*	Old Code
 * 	GAE Modification, number is still the same for a service link to n host
 * 
 * 	$DBRESULT =& $pearDBO->query("SELECT id FROM `index_data` WHERE service_id = '".$_REQUEST['svc_id']."' LIMIT 1");
 * 	if (PEAR::isError($DBRESULT))
 * 		print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
 *	$DBRESULT->fetchInto($index_data);
 *
 *	$DBRESULT =& $pearDBO->query("SELECT metric_id FROM `metrics` WHERE index_id = '".$index_data['id']."' ORDER BY metric_name");
 */	

/*	New Code
 * 
 * $DBRESULT =& $pearDBO->query("SELECT metric_id FROM `metrics` WHERE index_id = '".$index['id']."' ORDER BY metric_name");
 *  
 */
	        $DBRESULT =& $pearDBO->query("SELECT metric_id FROM `metrics` WHERE index_id = '".$index['id']."' ORDER BY metric_name");					
	        if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";				
			$targets = array();
			$cpt = 0;
			while ($DBRESULT->fetchInto($metrics)){
				$targets[$cpt] = $config["RRDdatabase_path"].$metrics["metric_id"].".rrd";
				$cpt++;
			}
				
			/*
			$DBRESULT =& $pearDB->query("SELECT oreon_path FROM `general_opt` LIMIT 1");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";				
			$oreon_path = $DBRESULT->fetchRow();		
			if (!$_REQUEST['link_target'])					
				$targets = preg_split('/\s+/',$oreon_path["oreon_path"]."filesGeneration/php-weathermap/rrd/".$_REQUEST['host_host_id_2']."_".$_REQUEST['svc_id'].".rrd",-1,PREG_SPLIT_NO_EMPTY); 
			else if (strstr($_REQUEST['link_target'], "filesGeneration/php-weathermap/rrd"))
				$targets = preg_split('/\s+/',$oreon_path["oreon_path"]."filesGeneration/php-weathermap/rrd/".$_REQUEST['host_host_id_2']."_".$_REQUEST['svc_id'].".rrd",-1,PREG_SPLIT_NO_EMPTY); 
			else
				$targets = preg_split('/\s+/',$_REQUEST['link_target'],-1,PREG_SPLIT_NO_EMPTY); 
			*/
			$new_target_list = array();
            			
            foreach ($targets as $target)
            {
               // we store the original TARGET string, and line number, along with the breakdown, to make nicer error messages later
               $newtarget = array($target,'traffic_in','traffic_out',0,$target);
            
              # if it's an RRD file, then allow for the user to specify the
              # DSs to be used. The default is traffic_in, traffic_out, which is
              # OK for Cacti (most of the time), but if you have other RRDs...
              if(preg_match("/(.*\.rrd):([\-a-zA-Z0-9_]+):([\-a-zA-Z0-9_]+)$/i",$target,$matches))
              {
                $newtarget[0] = $matches[1];
                $newtarget[1] = $matches[2];
                $newtarget[2] = $matches[3];
              }
			  // now we've (maybe) messed with it, we'll store the array of target specs
              $new_target_list[] = $newtarget;
			}
			$map->links[$link_name]->targets = $new_target_list;
         	
            $bwin = $_REQUEST['link_bandwidth_in'];
	   	    $bwout = $_REQUEST['link_bandwidth_out'];
			
			if(isset($_REQUEST['link_bandwidth_out_cb']))
			{
    			$bwout = $bwin;
			}
			
			$map->links[$link_name]->SetBandwidth($bwin,$bwout);
			if ($_REQUEST['host_host_id_2'] && $_REQUEST['svc_id'])	{
				$nodes = explode("-", $_REQUEST['link_name']);
				$DBRESULT =& $pearDB->query("SELECT * FROM `pwm_host_link_relation` WHERE `node_start_id` = '".$nodes[0]."' AND `node_end_id` = '".$nodes[1]."'");
				if (PEAR::isError($DBRESULT))
					print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";				
				if ($DBRESULT->numRows())	{
					$DBRESULT =& $pearDB->query("UPDATE `pwm_host_link_relation` SET service_service_id = '".$_REQUEST['svc_id']."' WHERE `node_start_id` = '".$nodes[0]."' AND `node_end_id` = '".$nodes[1]."'");
					if (PEAR::isError($DBRESULT))
						print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
				}
				else	{
					$DBRESULT =& $pearDB->query("INSERT INTO `pwm_host_link_relation` ( `phlr_id` , `host_host_id`, `service_service_id`, `node_start_id`, `node_end_id`) VALUES (NULL , '".$_REQUEST['host_host_id_2']."', '".$_REQUEST['svc_id']."', '".$nodes[0]."', '".$nodes[1]."'); ");
					if (PEAR::isError($DBRESULT))
						print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
				}
			}
			
            $map->WriteConfig($mapfile);
            break;
            
        case "set_map_properties":
			        
            $map->ReadConfig($mapfile);
                        
            $map->title = $_REQUEST['map_title'];
            $map->keytext = $_REQUEST['map_legend'];
            $map->stamptext = $_REQUEST['map_stamp'];

            $map->htmloutputfile = $_REQUEST['map_htmlfile'];
            $map->imageoutputfile = $_REQUEST['map_pngfile'];

            $map->width = intval($_REQUEST['map_width']);
            $map->height = intval($_REQUEST['map_height']);
	    
	    // XXX sanitise this a bit
	    if($_REQUEST['map_bgfile'] == '--NONE--')
	    {
		$map->background='';    
	    }
	    else
	    {
		$map->background = stripslashes($_REQUEST['map_bgfile']);
	    }
            
            $map->defaultlink->width = intval($_REQUEST['map_linkdefaultwidth']);
            
            $bwin = $_REQUEST['map_linkdefaultbwin'];
	    $bwout = $_REQUEST['map_linkdefaultbwout'];
                        
	    $map->defaultlink->SetBandwidth($bwin,$bwout);
                        
            $map->WriteConfig($mapfile);
            break; 

        case 'set_map_style':
			        
            $map->ReadConfig($mapfile);

            $map->defaultlink->labelstyle = $_REQUEST['mapstyle_linklabels'];
            $map->htmlstyle = $_REQUEST['mapstyle_htmlstyle'];
            $map->defaultlink->arrowstyle = $_REQUEST['mapstyle_arrowstyle'];

            $map->defaultlink->bwfont = intval($_REQUEST['mapstyle_linkfont']);
            $map->defaultnode->labelfont = intval($_REQUEST['mapstyle_nodefont']);
            $map->keyfont = intval($_REQUEST['mapstyle_legendfont']);

            $map->WriteConfig($mapfile);
            break;
        
        case "add_link":
			        
            $map->ReadConfig($mapfile);
			$param2 = $_REQUEST['param'];
            $newaction = 'add_link2';
            $selected = 'NODE:'.$param2;         
            break;
            
        case "add_link2":
			        
            $map->ReadConfig($mapfile);
            $a = $_REQUEST['param2'];
            $b = $_REQUEST['param'];
            $log = "[$a -> $b]";
            
            if($a != $b)
            {
                $newlink = new WeatherMapLink;
                $newlink->Reset($map);
                $newlink->a = $map->nodes[$a];
                $newlink->b = $map->nodes[$b];
                $newlink->SetBandwidth($map->defaultlink->max_bandwidth_in_cfg, $map->defaultlink->max_bandwidth_out_cfg);
                $newlink->width = $map->defaultlink->width;
		# make sure the link name is unique. We can have multiple links between
		# the same nodes, these days
		$newlinkname = "$a-$b";
		while(array_key_exists($newlinkname,$map->links))
		{
		    $newlinkname .= "a";
		}
                $newlink->name = $newlinkname;
                $map->links[$newlinkname] = $newlink;
                
                $map->WriteConfig($mapfile);
            }          
            break;

	case "place_legend":
			        
			$x = intval($_REQUEST['x']) - $x_oreon;
            $y = intval($_REQUEST['y']) - $y_oreon;
            
			$map->ReadConfig($mapfile);

			$map->keyx = $x;
            $map->keyy = $y;

            $map->WriteConfig($mapfile);
			break;
            
	case "place_stamp":
			        
			$x = intval($_REQUEST['x']) - $x_oreon;
            $y = intval($_REQUEST['y']) - $y_oreon;

			$map->ReadConfig($mapfile);

			$map->timex = $x;
            $map->timey = $y;

            $map->WriteConfig($mapfile);
			break;

        case "move_node":
			        
            $x = intval($_REQUEST['x']) - $x_oreon;
            $y = intval($_REQUEST['y']) - $y_oreon;
        	$node_name = $_REQUEST['node_name'];
		
            $map->ReadConfig($mapfile);

        	$map->nodes[$node_name]->x = $x;
        	$map->nodes[$node_name]->y = $y;

            $map->WriteConfig($mapfile);
            break;

        case "add_node":

			        
        
            $x = intval($_REQUEST['x']) - $x_oreon;
            $y = intval($_REQUEST['y']) - $y_oreon;

            $map->ReadConfig($mapfile);

            $node = new WeatherMapNode;
            $node->Reset($map);

            $node->x = snap($x);
            $node->y = snap($y);
            $node->name = "node".time();
            $node->label = "NODE";

            $map->nodes[$node->name] = $node;

            $map->WriteConfig($mapfile);
            break;
            
        case "delete_link":
			        
            $map->ReadConfig($mapfile);

            $target = $_REQUEST['param'];
            $log = "delete link ".$target;
            $nodes = explode("-", $_REQUEST['param']);
            $DBRESULT =& $pearDB->query("DELETE FROM `pwm_host_link_relation` WHERE `node_start_id` = '".$nodes[0]."' AND `node_end_id` = '".$nodes[1]."'");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";					
        
            unset($map->links[$target]);
        
            $map->WriteConfig($mapfile);
            break;
            
        case "delete_node":
			        
            $map->ReadConfig($mapfile);

            $target = $_REQUEST['param'];
            $log = "delete node ".$target;
           	$DBRESULT =& $pearDB->query("DELETE FROM `pwm_host_node_relation` WHERE `node_id` = '".$_REQUEST['param']."'");
			if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";					
        
            foreach ($map->links as $link)
                {
                    if( ($target == $link->a->name) || ($target == $link->b->name) )
                    {
                        unset($map->links[$link->name]);
                    }
                }           
        
            unset($map->nodes[$target]);
        
            $map->WriteConfig($mapfile);
            break;
            
        // no action was defined - starting a new map?
        default:
            $map->ReadConfig($mapfile);
            break;   
    }


    // now we'll just draw the full editor page, with our
    // new knowledge
    
    $imageurl = './modules/php-weathermap/configuration/pwm-editor/editor.php?mapname='.$mapname . '&amp;action=draw';


    if($selected != '')
    {
        $imageurl .= '&amp;selected='.$selected;
    }

    $imageurl .= '&amp;unique='.time();
    
    //$imlist = get_imagelist($imagesdir."images");
    $imlist = return_image_list(NULL, false);

echo $tmp;  

$fileOreonConf = $oreon->optGen["oreon_path"];
include("Ajax_js.php");  

?>

  <script type="text/javascript">
  // the only javascript in here should be the objects representing the map itself
  // all code should be in editor.js
  <?php print $map->asJS() ?>
  <?php
    
    // append any images used in the map that aren't in the images folder
 /*   foreach ($map->used_images as $im)
    {
	if(! in_array($im,$imlist))
	{
	    $imlist[]=$im;
	}
    }
  */     
   // sort($imlist);
    
    if(1==0)
    {
	$out = "";
	$out .= 'var mapimages = [';
	
	foreach ($imlist as $im)
	{
	    $out .= js_escape($im);
	    $out .= ",";
	}
	$out = rtrim($out,', ');
	$out .= "];\n";
	print $out;
    }
  ?>
  </script>


  <div id="toolbar">
    <ul>
      <li class="tb_help"><span id="tb_help"></span></li>
    </ul>
  </div>
  <div id="emptyblock">
	&nbsp;
  </div>


  <form action="?p=40411" method="post" name="frmMain">
    <div align="center">
    <input type="hidden" name="o" value="e">
     <input style="display:none" type="image"
      src="<?php echo $imageurl; ?>" id="xycapture" /><img src=
      "<?php echo $imageurl; ?>" id="existingdata" alt="Weathermap" usemap="#weathermap_imap"
       /><br />
       
       <div class="debug">Debugging: <input type="text" name="mapname" value="<?php echo $mapname; ?>" /><input 
      type="text" id="action" name="action" value="<?php echo $newaction ?>" /><input type="text" name=
      "param" id="param" value="" /><input type="text" name=
      "param2" id="param2" value="<?php echo $param2 ?>" /><input id="debug" value="" name="debug" /><br /><a target="configwindow" href="?action=show_config&amp;mapname=<?php echo $mapname ?>">See config</a>  <a href="?action=nothing&amp;mapname=<?php echo $mapname ?>">Do Nothing (Reload Cleanly)</a>
    	<?php echo $log ?>
      </div>
       <map name="weathermap_imap">
     <?php       	
            // we need to draw and throw away a map, to get the
            // dimensions for the imagemap. Oh well.
            $map->DrawMap('null');
            $map->htmlstyle='editor';
            $map->PreloadMapHTML();
         
            print $map->imap->subHTML("LEGEND");
            print $map->imap->subHTML("TIMESTAMP");
            print $map->imap->subHTML("NODE:");
            print $map->imap->subHTML("LINK:");
     ?>
           </map>
    </div><!-- Node Properties --->

    <div id="dlgNodeProperties" class="dlgProperties">
      <div class="dlgTitlebar">
        Node Properties
		<input size="6" name="node_name" type="hidden" />
        <ul>
          <li><a id="tb_node_submit" title="Submit any changes made" onclick=do_submit()>Submit</a></li>
          <li><a id="tb_node_cancel" title="Cancel any changes" onclick=cancel_op()>Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <table>
          <tr class=list_one>
            <th style="white-space: nowrap;">Internal Name</th>
            <td><input id="node_new_name" name="node_new_name" type="text" disabled/></td>
          </tr>
          <?php
          	$hosts = array(NULL=>NULL);
          	$DBRESULT =& $pearDB->query("SELECT host_id, host_name FROM host WHERE host_register = '1' ORDER BY host_name");		
          	if (PEAR::isError($DBRESULT))
				print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
          	while($DBRESULT->fetchInto($host))
				$hosts[$host["host_id"]] = $host["host_name"];
			$DBRESULT->free();          	
           ?>
          <tr class=list_two>
            <th style="white-space: nowrap;">Oreon Host</th>
            <td>
            <select id="host_host_id_1" name="host_host_id_1" OnChange="SetNodeInfos(this.value);">
            	<?php
            	foreach ($hosts as $key => $value)
            		echo "<option value=".$key.">".html_entity_decode($value, ENT_QUOTES)."</option>\n";
            	?>
            </select>
           </td>
          </tr>
          <input id="node_infourl" name="node_infourl" type="hidden" value=""/>
          <input id="node_hover" name="node_hover" type="hidden" value=""/>
          <tr class=list_one>
            <th style="white-space: nowrap;">Label</th>
            <td><input id="node_label" name="node_label" type="text" size="30"/></td>
          </tr>
          <!--
          <tr class=list_two>
            <th style="white-space: nowrap;">Info URL</th>
            <td style="white-space: nowrap;"><input id="node_infourl" name="node_infourl" type="text" size="50"/>&nbsp;(Fill by Oreon if blank)</td>
          </tr>
          <tr class=list_one>
            <th style="white-space: nowrap;">'Hover' Graph URL</th>
            <td style="white-space: nowrap;"><input id="node_hover" name="node_hover" type="text" size="50"/></td>
          </tr>
          -->
          <tr class=list_two>
            <th style="white-space: nowrap;">Icon Filename</th>
            <td><select id="node_iconfilename" name="node_iconfilename">
        	
	    <?php
		if(count($imlist)==0)
		{
		    print '<option value="--NONE--"></option>';
		}
		else
		{
		    print '<option value="--NONE--"></option>';
		    foreach ($imlist as $im)
		    {
			print "<option ";
			print "value=\"".$oreon->optGen["nagios_path_img"]."$im\">$im</option>\n";
		    }
		}
	    ?>		
		</select></td>
          </tr>
          <tr>
            <th></th>
            <td  style="white-space: nowrap;"><a id="node_move" class="dlgTitlebar" onclick=move_node()>Move Node</a><a class="dlgTitlebar" id="node_delete" onclick=delete_node()>Delete Node</a></td>
          </tr>
        </table>
      </div>

      <div class="list_two" id="node_help">
        Helpful text
      </div>
    </div><!-- Node Properties -->
    
    
    
    
    <!-- Link Properties -->

    <div id="dlgLinkProperties" class="dlgProperties">
      <div class="dlgTitlebar">
        Link Properties

        <ul>
          <li><a title="Submit any changes made" id="tb_link_submit"onclick=do_submit()>Submit</a></li>
          <li><a title="Cancel any changes" id="tb_link_cancel" onclick=cancel_op()>Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <div class="comment">
          Link from '<span id="link_nodename1">%NODE1%</span>' to '<span id="link_nodename2">%NODE2%</span>'
        </div>

		<input size="6" name="link_name" type="hidden" />

          <table>
	          <tr class=list_one>
	            <th>Oreon Host</th>
	            <td>
	            <input id="host_name_2" size="20" name="host_name_2" type="text"disabled/>
	            <input id="host_host_id_2" size="20" name="host_host_id_2" type="hidden"/>
	           </td>
	          </tr>
          <tr class=list_two>
            <th style="white-space: nowrap;">Service description</th>
            <td><select id="svc_id" name="svc_id">
			<option value="--NONE--">--NO SVC--</option>';
		</select></td>
          </tr>
          
            <tr class=list_one>
              <th style="white-space: nowrap;">Maximum Bandwidth<br />
              Into '<span id="link_nodename1a">%NODE1%</span>'</th>
              <td><input size="10" id="link_bandwidth_in" name="link_bandwidth_in" type=
              "text" /> bits/sec</td>
            </tr>
            <tr class=list_two>
              <th style="white-space: nowrap;">Maximum Bandwidth<br />
              Out of '<span id="link_nodename1b">%NODE1%</span>'</th>
              <td><input type="checkbox" id="link_bandwidth_out_cb" name=
              "link_bandwidth_out_cb" value="symmetric" />Same As
              'In' or <input id="link_bandwidth_out" name="link_bandwidth_out"
              size="10" type="text" /> bits/sec</td>
            </tr>
            <input id="link_target" size="50" name="link_target" type="hidden" value="" />
            <input id="link_infourl" size="50" name="link_infourl" type="hidden" value="" />
            <input id="link_hover"  size="50" name="link_hover" type="hidden" value=""/>
            <!--
            <tr class=list_one>
              <th style="white-space: nowrap;">Data Source</th>
              <td><input id="link_target" size="50" name="link_target" type="hidden" value="" />&nbsp;(Fill by Oreon if blank)</td>
            </tr>
            -->
            <tr class=list_one>
              <th style="white-space: nowrap;">Link Width</th>
              <td><input id="link_width" name="link_width" size="3" type="text" />
              pixels</td>
            </tr>
            <!--
            <tr class=list_one>
              <th style="white-space: nowrap;">Info URL</th>
              <td><input id="link_infourl" size="50" name="link_infourl" type="hidden" value="" />&nbsp;(Fill by Oreon if blank)</td>
            </tr>
            <tr class=list_two>
              <th style="white-space: nowrap;">'Hover' Graph URL</th>
              <td><input id="link_hover"  size="50" name="link_hover" type="hidden" value=""/>&nbsp;(Fill by Oreon if blank)</td>
            </tr>
            -->
            <tr>
              <th></th>
              <td><a class="dlgTitlebar" id="link_delete" onclick=delete_link()>Delete Link</a></td>
            </tr>
          </table>
      </div>

      <div  class="list_two"  id="link_help">
        Helpful text will appear here, depending on the current
        item selected. It should wrap onto several lines, if it's
        necessary for it to do that.
      </div>
    </div><!-- Link Properties -->

    <!-- Map Properties -->

    <div id="dlgMapProperties" class="dlgProperties">
      <div class="dlgTitlebar">
        Map Properties

        <ul>
          <li><a title="Submit any changes made" id="tb_map_submit"onclick=do_submit()>Submit</a></li>
          <li><a title="Cancel any changes" id="tb_map_cancel" onclick=cancel_op()>Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <table>
        <!--
          <tr class=list_one>
            <th style="white-space: nowrap;">Map Title</th>
            <td><input name="map_title" size="25" type="text" value="<?php echo $map->title ?>"/></td>
          </tr>
         -->
         <input name="map_title" type="hidden" value=""/>
        <tr class=list_two>
            <th style="white-space: nowrap;">Legend Text</th>
            <td><input name="map_legend" size="50" type="text" value="<?php echo $map->keytext ?>" /></td>
          </tr>
        <tr class=list_one>
            <th style="white-space: nowrap;">Timestamp Text</th>
            <td><input name="map_stamp" size="50" type="text" value="<?php echo $map->stamptext ?>" /></td>
          </tr>
        
        <tr class=list_two>
            <th style="white-space: nowrap;">Default Link Width</th>
            <td><input name="map_linkdefaultwidth" size="6" type="text" value="<?php echo $map->defaultlink->width ?>" /> pixels</td>
          </tr>
        
        <tr class=list_one>
            <th style="white-space: nowrap;">Default Link Bandwidth</th>
            <td><input name="map_linkdefaultbwin" size="6" type="text" value="<?php echo $map->defaultlink->max_bandwidth_in_cfg ?>" /> bit/sec in, <input name="map_linkdefaultbwout" size="6" type="text" value="<?php echo $map->defaultlink->max_bandwidth_out_cfg ?>" /> bit/sec out</td>
          </tr>
          
        
          <tr class=list_two>
            <th style="white-space: nowrap;">Map Size</th>
            <td><input name="map_width" size="5" type=
            "text"  value="<?php echo $map->width ?>" /> x <input name="map_height" size="5" type=
            "text"  value="<?php echo $map->height ?>" /> pixels</td>
          </tr><!--
           <tr class=list_one>
            <th style="white-space: nowrap;">Output PNG Filename</th>
            <td><input name="map_pngfile" type="text"  value="<?php echo $map->imageoutputfile ?>" /></td>
          </tr>
          <tr class=list_two>
            <th style="white-space: nowrap;">Output HTML Filename</th>
            <td><input name="map_htmlfile" type="text" value="<?php echo $map->htmloutputfile ?>" /></td>
          </tr>
          -->
          <input name="map_pngfile" type="hidden"  value="<?php echo $map->imageoutputfile ?>" />
          <input name="map_htmlfile" type="hidden" value="<?php echo $map->htmloutputfile ?>" />
          <tr class=list_one>
            <th style="white-space: nowrap;">Background Image Filename</th>
            <td><select name="map_bgfile">
	    
	      <?php
		if(count($imlist)==0)
		{
		    print '<option value="--NONE--">(no images are available)</option>';
		}
		else
		{
		    print '<option value="--NONE--">--NONE--</option>';
		    foreach ($imlist as $im)
		    {
			print "<option ";
			if($map->background == $im) print " selected ";			
			print "value=\"".$oreon->optGen["nagios_path_img"]."$im\">$im</option>\n";
		    }
		}
	    ?>
            </select></td>
          </tr>
        </table>
      </div>

      <div  class="list_two"  id="map_help">
        Helpful text 
      </div>
    </div><!-- Map Properties -->

    <!-- Map Style -->
    <div id="dlgMapStyle" class="dlgProperties">
      <div class="dlgTitlebar">
        Map Style

        <ul>
          <li><a title="Submit any changes made" id="tb_mapstyle_submit"onclick=do_submit()>Submit</a></li>
          <li><a title="Cancel any changes" id="tb_mapstyle_cancel" onclick=cancel_op()>Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <table>
          <tr class=list_two>
            <th style="white-space: nowrap;">Link Labels</th>
            <td><select name="mapstyle_linklabels">
              <option <?php echo ($map->defaultlink->labelstyle=='bits' ? 'selected' : '') ?> value="bits">Bits/sec</option>
              <option <?php echo ($map->defaultlink->labelstyle=='percent' ? 'selected' : '') ?> value="percent">Percentage</option>
              <option <?php echo ($map->defaultlink->labelstyle=='none' ? 'selected' : '') ?> value="none">None</option>
            </select></td>
          </tr>
          <tr class=list_one>
            <th style="white-space: nowrap;">HTML Style</th>
            <td><select name="mapstyle_htmlstyle">
              <option <?php echo ($map->htmlstyle=='overlib' ? 'selected' : '') ?> value="overlib">Overlib (DHTML)</option>
              <option <?php echo ($map->htmlstyle=='static' ? 'selected' : '') ?> value="static">Static HTML</option>
            </select></td>
          </tr>
          <tr class=list_two>
            <th style="white-space: nowrap;">Arrow Style</th>
            <td><select name="mapstyle_arrowstyle">
              <option <?php echo ($map->defaultlink->arrowstyle=='classic' ? 'selected' : '') ?> value="classic">Classic</option>
              <option <?php echo ($map->defaultlink->arrowstyle=='compact' ? 'selected' : '') ?> value="compact">Compact</option>
            </select></td>
          </tr>
          <tr class=list_one>
            <th style="white-space: nowrap;">Node Font</th>
            <td><select name="mapstyle_nodefont"><?php
                for($i=1; $i<6; $i++)
                {
                    print '<option ';
                    if($map->defaultnode->labelfont == $i) { print "selected "; }
                    print 'value="'.$i.'">'.$i.'</option>';
                }
		foreach ($map->fonts as $n => $font)
		{
		    print '<option ';
		    if($map->defaultnode->labelfont == $n) { print " selected "; }
		    print 'value="'.$n.'">'.$n.'</option>';
		}
            ?></select></td>
          </tr>
          <tr class=list_two>
            <th style="white-space: nowrap;">Link Label Font</th>
            <td><select name="mapstyle_linkfont"><?php
                for($i=1; $i<6; $i++)
                {
                    print '<option ';
                    if($map->defaultlink->bwfont==$i) { print "selected "; }
                    print 'value="'.$i.'">'.$i.'</option>';
                }
		foreach ($map->fonts as $n => $font)
		{
		    print '<option ';
		    if($map->defaultlink->bwfont == $n) { print " selected "; }
		    print 'value="'.$n.'">'.$n.'</option>';
		}
            ?></select></td>
          </tr>
          <tr class=list_one>
            <th style="white-space: nowrap;">Legend Font</th>
            <td><select name="mapstyle_legendfont"><?php
                for($i=1; $i<6; $i++)
                {
                    print '<option ';
                    if($map->keyfont==$i) { print "selected "; }
                    print 'value="'.$i.'">'.$i.'</option>';
                }
		foreach ($map->fonts as $n => $font)
		{
		    print '<option ';
		    if($map->keyfont == $n) { print " selected "; }
		    print 'value="'.$n.'">'.$n.'</option>';
		}
            ?></select></td>
          </tr>
          <tr class=list_two>
            <th style="white-space: nowrap;">Font Samples:</th>
            <td><img src="?action=font_samples&mapname=<?php echo $mapname?>" /><br />(Drawn using your PHP install)</td>
          </tr>
        </table>
      </div>

      <div  class="list_two"  id="mapstyle_help">
        Helpful text
      </div>
    </div><!-- Map Style -->



    <!-- Colours -->

    <div id="dlgColours" class="dlgProperties">
      <div class="dlgTitlebar">
        Manage Colors

        <ul>
          <li><a title="Submit any changes made" id="tb_colours_submit"onclick=do_submit()>Submit</a></li>
          <li><a title="Cancel any changes" id="tb_colours_cancel" onclick=cancel_op()>Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        Nothing in here works yet. The aim is to have a nice color picker somehow.
        <table>
          <tr class=list_one>
            <th>Background Color</th>
            <td></td>
          </tr>

          <tr class=list_two>
            <th>Link Outline Color</th>
            <td></td>
          </tr>
        <tr class=list_one>
        <th>Scale Colors</th>
        <td>Some pleasant way to design the bandwidth color scale goes in here???</td>
        </tr>

        </table>
      </div>

      <div  class="list_two"  id="colours_help">
        Helpful text
      </div>
    </div><!-- Colours -->


    <!-- Images -->

    <div id="dlgImages" class="dlgProperties">
      <div class="dlgTitlebar">
        Manage Images

        <ul>
          <li><a title="Submit any changes made" id="tb_images_submit"onclick=do_submit()>Submit</a></li>
          <li><a title="Cancel any changes" id="tb_images_cancel" onclick=cancel_op()>Cancel</a></li>
        </ul>
      </div>

      <div class="dlgBody">
        <p>Nothing in here works yet. </p>
        The aim is to have some nice way to upload images which can be used as icons or backgrounds.
        These images are what would appear in the dropdown boxes that don't currently do anything in the Node and Map Properties dialogs. This may end up being a seperate page rather than a dialog box...       
      </div>

      <div  class="list_two"  id="images_help">
        Helpful text
      </div>
    </div><!-- Images -->

  </form>
<?php
	} // if mapname != ''
?>
