<?php
/**
Oreon is developped with GPL Licence 2.0 :
http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
Developped by : Julien Mathis - Romain Le Merlus - Cedrick Facon

The Software is provided to you AS IS and WITH ALL FAULTS.
OREON makes no representation and gives no warranty whatsoever,
whether express or implied, and without limitation, with regard to the quality,
safety, contents, performance, merchantability, non-infringement or suitability for
any particular or intended purpose of the Software found on the OREON web site.
In no event will OREON be liable for any direct, indirect, punitive, special,
incidental or consequential damages however they may arise and even if OREON has
been previously advised of the possibility of such damages.

For information : contact@oreon-project.org
*/
	if (!isset ($oreon))
		exit ();

	$rq = "SELECT * FROM pwm_maps ORDER BY pwm_name";
	$DBRESULT =& $pearDB->query($rq);
	if (PEAR::isError($DBRESULT))
		print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
	
	# Smarty template Init
	$tpl = new Smarty();
	$tpl = initSmartyTpl($path, $tpl);
	
	# start header menu
	$tpl->assign("headerMenu_name", $lang['name']);
	$tpl->assign("headerMenu_alias", $lang['alias']);
	$tpl->assign("headerMenu_delete", $lang["modPHW_m_img_genDelete"]);
	$tpl->assign("headerMenu_create", $lang["modPHW_m_img_genCreate"]);
	# end header menu
	
	$elemArr = array();
	$style = "one";
	$i = 0;
	while ($DBRESULT->fetchInto($map))	{
		$elemArr[$i] = array("path_renderer"=>$path_renderer, "alias"=>$map["pwm_alias"], "name"=>$map["pwm_name"], "MenuClass"=>"list_".$style);
		if (is_file($path_renderer.$map["pwm_name"].".png"))	{
			unlink($path_renderer.$map["pwm_name"].".png");
			$elemArr[$i]["delete"] = $lang["yes"];
		}
		else
			$elemArr[$i]["delete"] = $lang["no"];
		system($path."weathermap.php --config ".$mapdir.$map["pwm_name"]." --htmloutput ".$path_renderer.$map["pwm_name"].".html  --output ".$path_renderer.$map["pwm_name"].".png");
		if (is_file($path_renderer.$map["pwm_name"].".html") && is_file($path_renderer.$map["pwm_name"].".png"))
			$elemArr[$i]["create"] = $lang["yes"];
		else
			$elemArr[$i]["create"] = $lang["no"];
		$style != "two" ? $style = "two" : $style = "one";	
		$i++;	
	}

	$tpl->assign("elemArr", $elemArr);
	
	$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
	$tpl->display("generateWeathermap.ihtml");
?>