<?php
/**
Oreon is developped with GPL Licence 2.0 :
http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
Developped by : Julien Mathis - Romain Le Merlus

The Software is provided to you AS IS and WITH ALL FAULTS.
OREON makes no representation and gives no warranty whatsoever,
whether express or implied, and without limitation, with regard to the quality,
safety, contents, performance, merchantability, non-infringement or suitability for
any particular or intended purpose of the Software found on the OREON web site.
In no event will OREON be liable for any direct, indirect, punitive, special,
incidental or consequential damages however they may arise and even if OREON has
been previously advised of the possibility of such damages.

For information : contact@oreon-project.org
*/

	function testMapExistence ($name = NULL)	{
		global $pearDB, $form;
		$id = NULL;
		if (isset($form))
			$id = $form->getSubmitValue('pwm_id');
		$DBRESULT =& $pearDB->query("SELECT pwm_name, pwm_id FROM pwm_maps WHERE pwm_name = '".htmlentities($name, ENT_QUOTES)."'");
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		$map =& $DBRESULT->fetchRow();
		#Modif case
		if ($DBRESULT->numRows() >= 1 && $map["pwm_id"] == $id)	
			return true;
		#Duplicate entry
		else if ($DBRESULT->numRows() >= 1 && $map["pwm_id"] != $id)	
			return false;
		else
			return true;
	}
	
	function deleteMapsInDB ($maps = array(), $mapdir = NULL, $path_renderer = NULL)	{
		global $pearDB;
		if ($mapdir && $path_renderer)	{
			foreach($maps as $key=>$value)	{
				$DBRESULT =& $pearDB->query("DELETE FROM pwm_maps WHERE pwm_name = '".htmlentities($key, ENT_QUOTES)."'");
				if (PEAR::isError($DBRESULT))
					print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
				if (file_exists($mapdir.$key))
					unlink($mapdir.$key);
				if (file_exists($path_renderer.$key.".png"))
					unlink($path_renderer.$key.".png");
				if (file_exists($path_renderer.$key.".html"))
					unlink($path_renderer.$key.".html");
			}
		}
	}
	
	function updateMapInDB ($pwm_id = NULL, $mapdir = NULL, $path_renderer = NULL)	{
		if (!$pwm_id) return;
			updateMap($pwm_id, $mapdir, $path_renderer);
	}
	
	function updateMap($pwm_id, $mapdir, $path_renderer)	{
		if (!$pwm_id) return;
		global $form;
		global $pearDB;
		$ret = array();
		$ret = $form->getSubmitValues();
		$rq = "SELECT pwm_name FROM pwm_maps WHERE pwm_id = '".$pwm_id."'";
		$DBRESULT =& $pearDB->query($rq);
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		$map_name = $DBRESULT->fetchRow();
		$rq = "UPDATE pwm_maps ";
		$rq .= "SET pwm_name = '".htmlentities($ret["pwm_name"], ENT_QUOTES)."', " .
				"pwm_alias = '".htmlentities($ret["pwm_alias"], ENT_QUOTES)."', " .
				"pwm_comment= '".htmlentities($ret["pwm_comment"], ENT_QUOTES)."' " .
				"WHERE pwm_id = '".$pwm_id."'";
		$DBRESULT =& $pearDB->query($rq);
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		if (file_exists($mapdir.$map_name["pwm_name"]))
			rename($mapdir.$map_name["pwm_name"], $mapdir.$ret["pwm_name"]);
		if (file_exists($path_renderer.$map_name["pwm_name"].".png"))
			rename($path_renderer.$map_name["pwm_name"].".png", $path_renderer.$ret["pwm_name"].".png");
		if (file_exists($path_renderer.$map_name["pwm_name"].".html"))
			rename($path_renderer.$map_name["pwm_name"].".html", $path_renderer.$ret["pwm_name"].".html");
	}
	
	function insertMapInDB ()	{
		$pwm_id = insertMap();
		return ($pwm_id);
	}
	
	function insertMap($ret = array())	{
		global $form, $pearDB;
		if (!count($ret))
			$ret = $form->getSubmitValues();
		$rq = "INSERT INTO pwm_maps ";
		$rq .= "(pwm_name, pwm_alias, pwm_comment) ";
		$rq .= "VALUES (";
		isset($ret["pwm_name"]) && $ret["pwm_name"] != NULL ? $rq .= "'".htmlentities($ret["pwm_name"], ENT_QUOTES)."', " : $rq .= "NULL, ";
		isset($ret["pwm_alias"]) && $ret["pwm_alias"] != NULL ? $rq .= "'".htmlentities($ret["pwm_alias"], ENT_QUOTES)."', " : $rq .= "NULL, ";
		isset($ret["pwm_comment"]) && $ret["pwm_comment"] != NULL ? $rq .= "'".htmlentities($ret["pwm_comment"], ENT_QUOTES)."' " : $rq .= "NULL ";
		$rq .= ")";
		$DBRESULT =& $pearDB->query($rq);
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		$DBRESULT =& $pearDB->query("SELECT MAX(pwm_id) FROM pwm_maps");
		$pwm_id = $DBRESULT->fetchRow();
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		return ($pwm_id["MAX(pwm_id)"]);
	}
?>