<?php
/**
Oreon is developped with GPL Licence 2.0 :
http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
Developped by : Julien Mathis - Romain Le Merlus - Cedrick Facon

The Software is provided to you AS IS and WITH ALL FAULTS.
OREON makes no representation and gives no warranty whatsoever,
whether express or implied, and without limitation, with regard to the quality,
safety, contents, performance, merchantability, non-infringement or suitability for
any particular or intended purpose of the Software found on the OREON web site.
In no event will OREON be liable for any direct, indirect, punitive, special,
incidental or consequential damages however they may arise and even if OREON has
been previously advised of the possibility of such damages.

For information : contact@oreon-project.org
*/

	$pwm = array();
	if (($o == "c" || $o == "w") && $pwm_id)	{
		$DBRESULT =& $pearDB->query("SELECT * FROM pwm_maps WHERE pwm_id = '".$pwm_id."' LIMIT 1");
		if (PEAR::isError($DBRESULT))
			print "DB Error : ".$DBRESULT->getDebugInfo()."<br>";
		# Set base value
		$pwm = array_map("myDecode", $DBRESULT->fetchRow());
	}
	##########################################################
	# Var information to format the element
	#
	$attrsText 		= array("size"=>"30");
	$attrsTextarea 	= array("rows"=>"5", "cols"=>"40");

	#
	## Form begin
	#
	$form = new HTML_QuickForm('Form', 'post', "?p=".$p."&o=a");
	if ($o == "a")
		$form->addElement('header', 'title', $lang["modPHW_addMap"]);
	else if ($o == "c")
		$form->addElement('header', 'title', $lang["modPHW_upMap"]);
	else if ($o == "w")
		$form->addElement('header', 'title', $lang["modPHW_viewMap"]);

	$form->addElement('header', 'information', $lang["modPHW_mapInfos"]);
	$form->addElement('text', 'pwm_name', $lang["modPHW_mapName"], $attrsText);
	$form->addElement('text', 'pwm_alias', $lang["modPHW_mapAlias"], $attrsText);
	$form->addElement('textarea', 'pwm_comment', $lang["modPHW_mapComment"], $attrsTextarea);

	$form->addElement('hidden', 'pwm_id');
	$redirect =& $form->addElement('hidden', 'o');
	$redirect->setValue($o);
	
	#
	## Form Rules
	#
	function myReplace()	{
		global $form;
		$ret = $form->getSubmitValues();
		return (str_replace(" ", "_", $ret["pwm_name"]));
	}
	$form->applyFilter('_ALL_', 'trim');
	$form->applyFilter('pwm_name', 'myReplace');
	$form->addRule('pwm_name', $lang['ErrName'], 'required');
	$form->addRule('pwm_alias', $lang['ErrName'], 'required');
	$form->registerRule('exist', 'callback', 'testMapExistence');
	$form->addRule('pwm_name', $lang['ErrAlreadyExist'], 'exist');
	
	$form->setRequiredNote($lang['requiredFields']);
	
	#
	##End of form definition
	#

	# Smarty template Init
	$tpl = new Smarty();
	$tpl = initSmartyTpl($path, $tpl);

	if ($o == "a")	{
		$subA =& $form->addElement('submit', 'submitA', $lang["save"]);
		$res =& $form->addElement('reset', 'reset', $lang["reset"]);
	}
	else if ($o == "c")	{
		$subC =& $form->addElement('submit', 'submitC', $lang["save"]);
		$res =& $form->addElement('reset', 'reset', $lang["reset"]);
	    $form->setDefaults($pwm);
	}

	$valid = false;
	if ($form->validate())	{
		$pwmObj =& $form->getElement('pwm_name');
		$pwmObjID =& $form->getElement('pwm_id');
		if ($form->getSubmitValue("submitC"))
			updateMapInDB($pwmObjID->getValue(), $mapdir, $path_renderer);
		else if ($form->getSubmitValue("submitA"))	{
			insertMapInDB();
			require_once 'editor-config.php';
		    require_once 'editor.inc.php';
			require_once 'Weathermap.class.php';
			$mapdir = $path_long.$mapdir;		
			$mapfile = $mapdir."/".str_replace(" ", "_", $pwmObj->getValue());
			$map = new WeatherMap;
			$map->context = "editor";		
			$map->WriteConfig($mapfile);
			$mapdir = $path.'configs/';
		}
		$form->addElement("button", "change", $lang['modify'], array("onClick"=>"javascript:window.location.href='?p=".$p."&o=c&pwm_id=".$pwmObjID->getValue()."'"));
		$o = NULL;
		$form->freeze();
		$valid = true;
	}
	
	if ($valid)
		require_once($path."listWeathermap.php");
	else	{
		$action = $form->getSubmitValue("action");
		#Apply a template definition
		$renderer =& new HTML_QuickForm_Renderer_ArraySmarty($tpl);
		$renderer->setRequiredTemplate('{$label}&nbsp;<font color="red" size="1">*</font>');
		$renderer->setErrorTemplate('<font color="red">{$error}</font><br />{$html}');
		$form->accept($renderer);
		$tpl->assign('form', $renderer->toArray());		
		$tpl->assign('o', $o);
		$tpl->display("FormWeathermap.ihtml");
	}
?>