<?php
	# Function to moove directory
	function copyr($source, $dest){
	  // Simple copy for a file
	  if (is_file($source)) {
		  $c = copy($source, $dest);
		  chmod($dest, 0764);
	 	 return $c;
      }
      // Make destination directory
      if (!is_dir($dest)) {
	      $oldumask = umask(0);
	      mkdir($dest, 0764);
      	umask($oldumask);
      }
      // Loop through the folder
      $dir = dir($source);
      while (false !== $entry = $dir->read()) {
	      // Skip pointers
	      if ($entry == '.' || $entry == '..')
	      	continue;
      // Deep copy directories
	      if ($dest !== $source."/".$entry)
	      copyr($source."/".$entry, $dest."/".$entry);
      }
      // Clean up
      $dir->close();
      return true;
    }
 
 	# Function to delete directory
	function rmdirr($dirname,$only_empty=false) {
	   if (!is_dir($dirname))
	       return false;
	   $dscan = array(realpath($dirname));
	   $darr = array();
	   while (!empty($dscan)) {
	       $dcur = array_pop($dscan);
	       $darr[] = $dcur;
	       if ($d=opendir($dcur)) {
	           while ($f=readdir($d)) {
	               if ($f=='.' || $f=='..')
	                   continue;
	               $f=$dcur.'/'.$f;
	               if (is_dir($f))
	                   $dscan[] = $f;
	               else
	                   unlink($f);
	           }
	           closedir($d);
	       }
	   }
	   $i_until = ($only_empty)? 1 : 0;
	   for ($i=count($darr)-1; $i>=$i_until; $i--) {
	       if (rmdir($darr[$i]))
	          ;
	   }
	   return (($only_empty)? (count(scandir)<=2) : (!is_dir($dirname)));
	}
?>
